package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.List;
import org.antlr.tool.Grammar;
import org.antlr.tool.Rule;

public class CompositeGrammarTree {
  protected List<org.antlr.tool.CompositeGrammarTree> children;
  
  public Grammar grammar;
  
  public org.antlr.tool.CompositeGrammarTree parent;
  
  public CompositeGrammarTree(Grammar g) {
    this.grammar = g;
  }
  
  public void addChild(org.antlr.tool.CompositeGrammarTree t) {
    if (t == null)
      return; 
    if (this.children == null)
      this.children = new ArrayList<org.antlr.tool.CompositeGrammarTree>(); 
    this.children.add(t);
    t.parent = this;
  }
  
  public Rule getRule(String ruleName) {
    Rule r = this.grammar.getLocallyDefinedRule(ruleName);
    for (int i = 0; r == null && this.children != null && i < this.children.size(); i++) {
      org.antlr.tool.CompositeGrammarTree child = this.children.get(i);
      r = child.getRule(ruleName);
    } 
    return r;
  }
  
  public Object getOption(String key) {
    if (this.grammar.tool != null && key != null && key.equals("language") && this.grammar.tool.forcedLanguageOption != null)
      return this.grammar.tool.forcedLanguageOption; 
    Object o = this.grammar.getLocallyDefinedOption(key);
    if (o != null)
      return o; 
    if (this.parent != null)
      return this.parent.getOption(key); 
    return null;
  }
  
  public org.antlr.tool.CompositeGrammarTree findNode(Grammar g) {
    if (g == null)
      return null; 
    if (this.grammar == g)
      return this; 
    org.antlr.tool.CompositeGrammarTree n = null;
    for (int i = 0; n == null && this.children != null && i < this.children.size(); i++) {
      org.antlr.tool.CompositeGrammarTree child = this.children.get(i);
      n = child.findNode(g);
    } 
    return n;
  }
  
  public org.antlr.tool.CompositeGrammarTree findNode(String grammarName) {
    if (grammarName == null)
      return null; 
    if (grammarName.equals(this.grammar.name))
      return this; 
    org.antlr.tool.CompositeGrammarTree n = null;
    for (int i = 0; n == null && this.children != null && i < this.children.size(); i++) {
      org.antlr.tool.CompositeGrammarTree child = this.children.get(i);
      n = child.findNode(grammarName);
    } 
    return n;
  }
  
  public List<Grammar> getPostOrderedGrammarList() {
    List<Grammar> grammars = new ArrayList<Grammar>();
    _getPostOrderedGrammarList(grammars);
    return grammars;
  }
  
  protected void _getPostOrderedGrammarList(List<Grammar> grammars) {
    for (int i = 0; this.children != null && i < this.children.size(); i++) {
      org.antlr.tool.CompositeGrammarTree child = this.children.get(i);
      child._getPostOrderedGrammarList(grammars);
    } 
    grammars.add(this.grammar);
  }
  
  public List<Grammar> getPreOrderedGrammarList() {
    List<Grammar> grammars = new ArrayList<Grammar>();
    _getPreOrderedGrammarList(grammars);
    return grammars;
  }
  
  protected void _getPreOrderedGrammarList(List<Grammar> grammars) {
    grammars.add(this.grammar);
    for (int i = 0; this.children != null && i < this.children.size(); i++) {
      org.antlr.tool.CompositeGrammarTree child = this.children.get(i);
      child._getPreOrderedGrammarList(grammars);
    } 
  }
  
  public void trimLexerImportsIntoCombined() {
    org.antlr.tool.CompositeGrammarTree p = this;
    if (p.grammar.type == 1 && p.parent != null && p.parent.grammar.type == 4)
      p.parent.children.remove(this); 
    for (int i = 0; this.children != null && i < this.children.size(); i++) {
      org.antlr.tool.CompositeGrammarTree child = this.children.get(i);
      child.trimLexerImportsIntoCombined();
    } 
  }
}
